<template>
  <header ref="Header" class="shadow-lg">
    <div class="p-4 text-lg flex h-26 items-center">
      <router-link @click.prevent="clearSearch" to="/" class="ml-4 mr-4">Medic</router-link>
      <div class="search">
        <input v-model="queryText" type="text" placeholder="Search">
      </div>
      <div class="ml-auto mr-4 text-sm flex items-center">
        <p class="mb-0 mr-2">Petrova Oksana</p>
        <q-avatar>
          <img src="https://cdn.quasar.dev/img/avatar.png">
        </q-avatar>
      </div>
    </div>
  </header>
</template>

<script>
import Modal from "./Modal.vue";
import LoadsSpinner from "./Loads-spinner.vue";
import {ref, watch} from "vue";
import axios from "axios";
import {useStore} from "vuex";
export default {
  name: "Header",
  components: {LoadsSpinner, Modal},
  setup() {
    const store = useStore()
    const searchArray = ref([])
    const issueSearch = ref(false)
    const queryText = ref('')

    function debounce(func, wait, immediate) {
      let timeout;

      return function executedFunction() {
        const context = this;
        const args = arguments;

        const later = function() {
          timeout = null;
          if (!immediate) func.apply(context, args);
        };

        const callNow = immediate && !timeout;

        clearTimeout(timeout);

        timeout = setTimeout(later, wait);

        if (callNow) func.apply(context, args);
      };
    }
    async function searchFunction() {
      let str = queryText.value
      if (!str.length || str.length <= 2) {
        store.commit('SEARCH', [])
      }
      if (str.length > 2) {
        await axios.get(`http://188.120.231.191:3000/lab_research?name_lr=like.*${str}*`)
          .then(res => {
            if (res.data.length) {
              searchArray.value = res.data
              store.commit('SEARCH', searchArray.value)
            }
            else return issueSearch.value = true
          })
      }
    }
    function clearSearch () {
      localStorage.removeItem('index')
      localStorage.removeItem('Category')
      localStorage.removeItem('LaboratoryResearch')
      store.commit('SEARCH_CLEAR')
    }

    watch(queryText, debounce(searchFunction, 500))

    return {
      searchArray,
      queryText,
      issueSearch,
      clearSearch
    }
  }
}
</script>

<style scoped lang="scss">
.search {
  position: relative;
  margin-bottom: 20px;
  input {
    border-bottom: 1px solid #b0b0b0;
    padding-left: 5px;
    display: block;
    &::placeholder {
      font-size: 14px;
      opacity: 0.5;
    }
    &:active, &:hover, &:focus {
      outline: 0;
      outline-offset: 0;
      border-bottom: 1px solid black;
    }
  }
  &:before {
    display: block;
    background: url("../assets/images/icons/magnify.svg") center;
    position: absolute;
    width: 20px;
    height: 20px;
  }
}
</style>
